// align.c by kaz

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define AREA	256

typedef unsigned int	INT32;
typedef unsigned short	INT16;
typedef unsigned char	INT8;

extern int px,py;
extern int ax,ay;
extern int verb;

INT16	*I[2];
int	colors=3;	// 3:DEBUG

#ifdef TANTAI
void
usage(){
	printf("Usage:	align image0.pgm image1.pgm\n"
		"\tAccept only 16bit rawbit pgm image.\n");
	exit(1);
}
#endif

//////// read image
int
readi(FILE *f, int i, int *x, int *y, int th){
char	buf[256];
int	depth,j;
int	sx,sy;	//size
int	a,b,c;

	sx=sy=AREA;

	fgets(buf,256,f);
	if(!strcmp(buf,"P6")){
		printf("Sorry, I can read ONLY 'P6' rawbit ppm.\n");
		exit(1);
	}
	fgets(buf,256,f);
	sscanf(buf,"%d %d",x,y);
#if 0
	if(*x!=AREA||*y!=AREA){
		printf("Sorry, I can read ONLY 256x256.\n");
		exit(1);
	}
#endif
	fgets(buf,256,f);
	depth=atoi(buf);
	if(depth!=65535){
		printf("Sorry, I can read ONLY 16bit(65535) depth.\n");
		exit(1);
	}
	if(ax== -1) ax= *x/2;
	if(ay== -1) ay= *y/2;
	if(verb) printf("DEBUG(align): ax=%d ay=%d th=%d\n",ax,ay,th);
	I[i]=malloc(sx * sy * sizeof(*I[i]) * colors);
	fseek(f,*x *colors*sizeof(*I[i])* ay,SEEK_CUR);
	for(j=0;j<sy;j++){
		fseek(f,ax *colors*sizeof(*I[i]), SEEK_CUR);
		fread(I[i]+sx*colors*j, sx *colors*sizeof(*I[i]),1,f);
		fseek(f,(*x-ax-sx)*colors*sizeof(*I[i]), SEEK_CUR);
	}
	swab(I[i],I[i],sx * colors * sy * sizeof(*I[i]));

	for(b= 0; b<sy; b++){
		for(a= 0; a<sx; a++){
			for(c= 0; c<colors; c++){
				*(I[i]+(c+(a+b*AREA)*colors))=
					(*(I[i]+(c+(a+b*AREA)*colors))<th)? 0:1;
			}
		}
	}

	return 0;
}

//////// $B2hA|$N0c$$$r7W$k(B
int
dif(int x0, int y0, INT32 d0){
int x,y,c;
INT32 d=0;

	for(y= py; y<AREA-py; y++){
		for(x= px; x<AREA-px; x++){
//			for(c= 0; c<colors; c++){
			for(c= 0; c<1; c++){
				d+= abs(*(I[0]+(c+(x+y*AREA)*colors))-
					*(I[1]+(c+((x0+x)+(y0+y)*AREA)*colors)));
							// >>4:$B7e0n$lKI;_(B
				if(d>d0) return d;	// cut-off
			}
		}
	}
	return d;
}

//////// $B2hA|$N0c$$$,:G>.$H$J$k%:%l$rC5$9(B
int
pivot(int *x0, int *y0, INT32 d0){
int x,y;
char r;
INT32 d=0;

	if(verb) printf("DEBUG: px=%d py=%d\n",px,py);
	for(y= -py; y<=py; y++){
		for(x= -px; x<=px; x++){
			d=dif(x,y,d0);
			if(d<d0){
				*x0=x; *y0=y; d0=d;
				r=(abs(x)==px || abs(y)==py)? '!':' ';
//				if(verb) printf("DEBUG: %+3d %+3d %15u %c\n",x,y,d,r);
			}
		}
	}
	return d0;
}

#ifdef TANTAI
//////// main
int
main(int ac, char **av){
INT32	d,d0;
int	ax,ay,bx,by,x0,y0;
FILE	*f[2];

	if(ac!=3) usage();

	for(int i=0; i<2; i++){
		f[i]=fopen(av[i+1],"r");
		if(f[i]==NULL){
			perror(av[i+1]); exit(1);
		}
	}

	readi(f[0],0,&ax,&ay);
	readi(f[1],1,&bx,&by);
	if((ax!=bx)||(ay!=by)){
		fprintf(stderr,"size miss match!\n");
		exit(1);
	}

	d0=(-1);	// MAX
	d=pivot(&x0,&y0,d0);
	printf("%+3d %+3d %15u\n",x0,y0,d);

	return 0;
}
#endif
