/* Repair hot & cold pixels
For int8, int16, float32 bit & mono, RGB, RGBG color images.

2005/02/07 by NAKAMURA Kazushi
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/param.h>
#include "pile.h"

enum{
	MEAN,
	MEDIUM
} alg;

enum{
	PRW,
	PPM,
	PGM
} outfmt;

enum{
	RED,
	GREEN,
	BLUE
} color;

/*** defaults ***/
int odepth=16;		//ϳĴ 8,16,-32(float)

/*** global ***/
int ix,iy;		// Input image size
int ox,oy;		// Output image size
INT16 *I,*O;
FILE *ifp,*ofp;
int verb;

void usage(){
	fprintf(stderr,"Usage: hotcold [-t #%%] in.ppm out.ppm\n");
	exit(1);
}

unsigned int avg(int x,int y,int c,int cs){
unsigned int a;
	a= ( I[((y-1)*ix+(x-1))*cs+c]
		+I[((y-1)*ix+(x  ))*cs+c]
		+I[((y-1)*ix+(x+1))*cs+c]
		+I[((y  )*ix+(x-1))*cs+c]

		+I[((y  )*ix+(x+1))*cs+c]
		+I[((y+1)*ix+(x-1))*cs+c]
		+I[((y+1)*ix+(x  ))*cs+c]
		+I[((y+1)*ix+(x+1))*cs+c] )/8;
	return a;
}

int main(int ac, char **av){
int ch,d,colors,depth,th;
int x,y,x0,y0;
unsigned int a0,d0;
int i,j,c;
int xx,yy;
char r,buf[256];

/*** defaults ***/
	outfmt=PPM;
	colors=3;
	th=8;	// 8%

/*** option ***/
	while((ch=getopt(ac,av,"vt:")) != -1)
		switch(ch){
		case 'v':
			verb=1;
			break;
		case 't':
			th=atoi(optarg);
			break;
		default:
			usage();
		}
	ac-=optind;
	av+=optind;

	if(verb) printf("v=%d th=%d ac=%d\n"
		,verb,th,ac);

	ifp=fopen(av[0],"r");
	if(ifp==NULL){
		perror(av[0]); exit(1);
	}
	ofp=fopen(av[1],"w");
	if(ofp==NULL){
		perror(av[1]); exit(1);
	}

        fgets(buf,256,ifp);
        if(!strcmp(buf,"P6")){
                printf("Sorry, I can read ONLY 'P6' rawbit ppm.\n");
                exit(1);
        }
        fgets(buf,256,ifp);
        sscanf(buf,"%d %d",&ix,&iy);
        fgets(buf,256,ifp);
        depth=atoi(buf);
        if(depth!=65535){
                printf("Sorry, I can read ONLY 16bit(65535) depth.\n");
                exit(1);
        }

	////output size
	ox=ix;
	oy=iy;

	//DEBUG only PPM
	fprintf(ofp,"P6\n%d %d\n%d\n", ox,oy, (1<<odepth)-1);
	fflush(ofp);

	I=malloc(ix * iy * sizeof(*I) * colors);
	O=malloc(ox * oy * sizeof(*O) * colors);

	////input a image
	fread(I,ix*iy*sizeof(*I)*colors,1,ifp);
	swab(I,I,ix*iy*sizeof(*I)*colors);

	for(yy=1;yy<oy-1;yy++){
		for(xx=1;xx<ox-1;xx++){
			for(c=0;c<colors;c++){
				d0=I[(yy*ix+xx)*colors+c];
				a0=avg(xx,yy,c,colors)+1;
				O[(yy*ix+xx)*colors+c]= (100*abs(d0-a0)/a0 >th)? a0:d0;
//				O[(yy*ix+xx)*colors+c]= a0-1;
			}
		}
	}

	////output a image
	swab(O,O,ix*iy*sizeof(*O)*colors);
	fwrite(O,ox*oy*sizeof(*O)*colors,1,ofp);
	fflush(ofp);

	return 0;
}
