/* ppm to pgm
For int8, int16, float32 bit & mono, RGB, RGBG color images.

2004/12/25 by NAKAMURA Kazushi
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/param.h>
#include "pile.h"

enum{
	MEAN,
	MEDIUM
} alg;

enum{
	PRW,
	PPM,
	PGM
} outfmt;

enum{
	RED,
	GREEN,
	BLUE
} color;

/*** defaults ***/
int odepth=16;		//ϳĴ 8,16,-32(float)

/*** global ***/
int ix,iy;		// Input image size
int ox,oy;		// Output image size
INT16 *I,*O;
FILE *ifp,*ofp;
int verb;

void usage(){
	fprintf(stderr,"Usage: ppm2pgm [-r|-g|-b] in.ppm out.pgm\n");
	exit(1);
}

int main(int ac, char **av){
int ch,d,colors,depth;
int x,y,x0,y0;
unsigned int d0;
int i,j,c;
int xx,yy;
char r,buf[256];

/*** defaults ***/
	outfmt=PGM;
	colors=3;
	color=RED;

/*** option ***/
	while((ch=getopt(ac,av,"vrgb")) != -1)
		switch(ch){
		case 'v':
			verb=1;
			break;
		case 'r':
			color=RED;
			break;
		case 'g':
			color=GREEN;
			break;
		case 'b':
			color=BLUE;
			break;
		default:
			usage();
		}
	ac-=optind;
	av+=optind;

	if(verb) printf("v=%d alg=%d color=%d fmt=%d ac=%d\n"
		,verb,alg,color,outfmt,ac);

	ifp=fopen(av[0],"r");
	if(ifp==NULL){
		perror(av[0]); exit(1);
	}
	ofp=fopen(av[1],"w");
	if(ofp==NULL){
		perror(av[1]); exit(1);
	}

        fgets(buf,256,ifp);
        if(!strcmp(buf,"P6")){
                printf("Sorry, I can read ONLY 'P6' rawbit ppm.\n");
                exit(1);
        }
        fgets(buf,256,ifp);
        sscanf(buf,"%d %d",&ix,&iy);
        fgets(buf,256,ifp);
        depth=atoi(buf);
        if(depth!=65535){
                printf("Sorry, I can read ONLY 16bit(65535) depth.\n");
                exit(1);
        }

	////output size
	ox=ix;
	oy=iy;

	//DEBUG only PGM
	fprintf(ofp,"P5\n%d %d\n%d\n", ox,oy, (1<<odepth)-1);
	fflush(ofp);

        I=malloc(ix * iy * sizeof(*I) * colors);
        O=malloc(ox * oy * sizeof(*O) * 1);

	////output a plane
	for(yy=0;yy<oy;yy++){
		fread(I,ix*sizeof(*I)*colors,1,ifp);
		for(xx=0;xx<ox;xx++){
			O[xx*1]=I[xx*colors+color];
		}
		fwrite(O,ox*sizeof(*O)*1,1,ofp);
		fflush(ofp);
	}

	return 0;
}
